#include <stdio.h>
#include <stdint.h>
#include <curl/curl.h>
#include <libxml/parser.h>
#include <libxml/tree.h>

#include <opctime.h>
#include <opcxml.h>
#include "dime.h"


int mainbk() {
    CURL *curl;
    CURLcode res;
    FILE *thefile;
    xmlDocPtr doc;
    xmlNodePtr node;
    double time1, time2, duration;
    const char *rcvtime, *replytime, *content_type;
    struct OPCTimeT otime1, otime2;
    struct OPCDurationT oduration;
    
//    char request[256]="<GetStatus xmlns=\"http://opcfoundation.org/webservices/XMLDA/1.0/\"/>";
    char request[256]="<Read xmlns=\"http://opcfoundation.org/webservices/XMLDA/1.0/\"><ItemList ItemPath=\"/Examples/random2\"><Item ItemName=\"complex\"/></ItemList></Read>";
    
    struct curl_httpost *xml_post=NULL;
    struct curl_httpost *last_post=NULL;
    
    
    thefile = fopen("output.xml", "w");
    
    curl_global_init(CURL_GLOBAL_ALL);
    
    curl=curl_easy_init();
/*    
    curl_formadd(&xml_post,&last_post, 
	CURLFORM_COPYNAME, "opc", 
	CURLFORM_PTRCONTENTS, request,
	CURLFORM_CONTENTSLENGTH, strlen(request),
	CURLFORM_END);
*/

//    curl_easy_setopt(curl, CURLOPT_HEADER, 1);
    curl_easy_setopt(curl, CURLOPT_URL, "http://ipepc47.ka.fzk.de/opc/hell.opc");
//    curl_easy_setopt(curl, CURLOPT_HTTPPOST, xml_post);
    curl_easy_setopt(curl, CURLOPT_POSTFIELDS, request);

    curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, writefunc);
    curl_easy_setopt(curl, CURLOPT_WRITEDATA, thefile);
    
    res = curl_easy_perform(curl);
    
//    curl_formfree(xml_post);
    
    curl_easy_getinfo(curl, CURLINFO_TOTAL_TIME, &time1);
    curl_easy_getinfo(curl, CURLINFO_CONNECT_TIME, &time2);
    curl_easy_getinfo(curl, CURLINFO_CONTENT_TYPE, &content_type);
    

    curl_easy_cleanup(curl);
    
    fclose(thefile);
    

    printf("\n");
    printf("Connect  Time: %.3lfms\n", time2*1000);
    printf("Request  Time: %.3lfms\n", time1*1000);
//    puts(content_type); problem

    
    doc = xmlReadFile("output.xml", NULL, 0);
    node=xmlDocGetRootElement(doc)->children;
    rcvtime=opcXmlGetPropString(node,"RcvTime",NULL);
    replytime=opcXmlGetPropString(node,"ReplyTime",NULL);
    opcTimeSetDateTime(&otime1, rcvtime);
    opcTimeSetDateTime(&otime2, replytime);
    opcTimeCalcDuration(&oduration, &otime1, &otime2);
    xmlFreeDoc(doc);
    duration = 1000.*oduration.s + 1.*oduration.us/1000;
//    printf("%lu %lu\n",otime1.s,otime1.us);
//    printf("%lu %lu\n",otime2.s,otime2.us);
//    printf("%lu %lu\n",oduration.s,oduration.us);
    printf("Internal Time: %.3lfms\n", duration);
    
    printf("\n");

}

CURL *curl;

double smin=1E+10, smax=0, smid=0;
double rmin=1E+10, rmax=0, rmid=0;
unsigned long iters=0;

int mainloop() {
    CURLcode res;
    FILE *thefile;
    xmlDocPtr doc;
    xmlNodePtr node;
    double time1, time2, time3, duration;
    const char *rcvtime, *replytime;
    struct OPCTimeT otime1, otime2;
    struct OPCDurationT oduration;
    struct timeval tm1, tm2, tm3;
    
//    char request[256]="<GetStatus xmlns=\"http://opcfoundation.org/webservices/XMLDA/1.0/\"/>";
    char request[256]="<Read xmlns=\"http://opcfoundation.org/webservices/XMLDA/1.0/\"><ItemList ItemPath=\"/Examples/random\"><Item ItemName=\"complex\"/></ItemList></Read>";
    
    struct curl_httpost *xml_post=NULL;
    struct curl_httpost *last_post=NULL;
    
    
    thefile = fopen("output.xml", "w");
    
    curl_easy_setopt(curl, CURLOPT_URL, "http://localhost/opc/hell.opc");
//    curl_easy_setopt(curl, CURLOPT_URL, "http://ipepc47.ka.fzk.de/opc/hell.opc");
    curl_easy_setopt(curl, CURLOPT_POSTFIELDS, request);
    curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, writefunc);
    curl_easy_setopt(curl, CURLOPT_WRITEDATA, thefile);

    dime = 0;
    
    gettimeofday(&tm1,NULL);
    res = curl_easy_perform(curl);
    gettimeofday(&tm2,NULL);

    time1 = 1.*((tm2.tv_sec - tm1.tv_sec)*1000000 + tm2.tv_usec - tm1.tv_usec)/1000;
    
    curl_easy_getinfo(curl, CURLINFO_TOTAL_TIME, &time2);
    curl_easy_getinfo(curl, CURLINFO_CONNECT_TIME, &time3);
    
    
    fclose(thefile);

    if (dime<-1) return;
    
    printf("\n");
    printf("Connect: %.3lfms, ", time3*1000);
    printf("Request: %.3lfms, ", time2*1000);

    
    doc = xmlReadFile("output.xml", NULL, 0);
    node=xmlDocGetRootElement(doc)->children;
    rcvtime=opcXmlGetPropString(node,"RcvTime",NULL);
    replytime=opcXmlGetPropString(node,"ReplyTime",NULL);
    opcTimeSetDateTime(&otime1, rcvtime);
    opcTimeSetDateTime(&otime2, replytime);
    opcTimeCalcDuration(&oduration, &otime1, &otime2);
    xmlFreeDoc(doc);
    duration = 1000.*oduration.s + 1.*oduration.us/1000;
    printf("Internal: %.3lfms\n", duration);
    
    if (duration<smin) smin=duration;
    if (duration>smax) smax=duration;
    smid = (smid*iters + duration)/(iters+1);

    if (time1<rmin) rmin=time1;
    if (time1>rmax) rmax=time1;
    rmid = (rmid*iters + time1)/(iters+1);
    
    printf("Internal: %3.3lf(%.3lf,%.3lf)ms, iter: %lu\n",smid,smin,smax,iters);
    printf("Request : %3.3lf(%.3lf,%.3lf)ms, iter: %lu\n",rmid,rmin,rmax,iters);
    iters++;
    printf("\n");
}

int main(int argc, char *argv[]) {
    unsigned long iters = 1;
    
    
    if (argc>=2) {
	iters = atol(argv[1]);
	if (!iters) iters=-1;
    }

    curl_global_init(CURL_GLOBAL_ALL);
    curl=curl_easy_init();
    
    for (;iters>0;iters--) {
	mainloop();
//	sleep(1);
    }

    curl_easy_cleanup(curl);
}
