#include <backend.h>
#include <opcplugin.h>
#include <opcitem.h>

#include <opctype.h>
#include <opcfdopcbinarydictionary.h>

#include <opcallocator.h>

#define SIZE 65536 /* Change in dictionary!!! */
#define STEPS 8
#define SKIP 5
#define CLIENTS 3

//#define FAST_DATA_MANAGER
//#define FAST_DATA_MANAGER_XML
#define LEGACY_DATA_MANAGER
//#define LEGACY_DATA_MANAGER_BINARY
//#define LEGACY_DATA_MANAGER_DATABUFFER
//#define PUSH_BENCH


struct _random_simple_t {
    short int i16;
    unsigned long int ui32;
    double dbl;
};

// rewrite truth uint32
struct _random_complex_t {
    short int i16;
    unsigned long int ui32;
    double dbl;
    double array[SIZE];
};

struct _random {
    unsigned char items;
    unsigned long *item;
};

typedef struct RandomContextT *RandomContext;

struct RandomContextT {
    OPCPluginContext pctx;
    OPCItemContext ictx;
    OPCType type;
    OPCFDOPCBinaryDictionaryContext dict;
#ifdef FAST_DATA_MANAGER
    OPCDataFastContext dm;
#endif
#ifdef LEGACY_DATA_MANAGER
    OPCDataContext dm;
#endif
    
    OPCAllocatorContext allocator;
    struct _random data;
};

RandomContext randomCreateContext();
int randomInitContext(RandomContext ctx, OPCPluginContext pctx, OPCBackendContext bctx);
int randomRun(RandomContext ctx);
void randomFreeContext(RandomContext ctx);
void randomDestroyContext(RandomContext ctx);


struct PluginInfoContextT info = {
    "random",
    "1.0",
    (plugin_create_function)&randomCreateContext,
    (plugin_init_function)&randomInitContext,
    (plugin_step_function)&randomRun,
    (plugin_free_function)&randomFreeContext,
    (plugin_destroy_function)&randomDestroyContext
};
