#ifndef _OPCCONFIG_H
#define _OPCCONFIG_H
#include <sys/socket.h>

#ifdef _GNU_SOURCE
#define OPC_SUPPORT_RWLOCK		/* Switch on "One Write Multiple Read" Locking */
#endif /* _GNU_SOURCE */

#define FRONTEND_NETWORK_PORT 8001

#define _DEBUG_SERVER stdout		/* Debugging server on */
#define _DEBUG_OPC stdout		/* Debugging requests on */
#define _DEBUG_XML

#define OPC_OPTION_SCALE_FACTOR		10


#define lgs(str) str

#define opc_version_major		"0"
#define opc_version_minor		"1"
#define opc_version_build		1
#define opc_vendor_info			lgs("DarkSoft")
#define opc_message_catalog_dir		"/usr/share/opc/locale"
#define opc_servers_dir			"/usr/share/opc/servers"
#define opc_text_domain			"opc"

#define opc_temp_dir 			"/tmp/opc/"
#define opc_server_name			"hell"
#define opc_sockets_dir			opc_temp_dir opc_server_name ".opc/"
#define backend_socket_name		opc_sockets_dir "bsocket"
#define frontend_socket_name		opc_sockets_dir "socket"

#define max_server_name 32
#define opc_reqresp_buffer_size 255
#define opc_buffer_size 65535
#define opc_maintain_delay 30		/* seconds */

#define opc_max_items			10
#define opc_max_paths			20

#define OPC_FECMD_NEWREQ 		0
#define OPC_FECMD_ZTMESSAGE		0		/* Zero Terminated Message */
#define OPC_FECMD			0xFFFF0000
#define OPC_FECMD_INVALIDREQ		0xFFFFFFFF
#define OPC_FECMD_XMLEND		0xFFFFFFFE
#define OPC_FECMD_RCERROR		0xFFFFFFFD
#define OPC_FECMD_OPC_INVALIDREQ	0xFFFFFFFC
#define OPC_FECMD_REPEAT		0xFFFFFFFB
#define OPC_FECMD_CANCEL		0xFFFFFFFA
#define OPC_FECMD_BUSY			0xFFFFFFF9
#define OPC_FECMD_INTERNAL_ERROR	0xFFFFFFF8
#define OPC_FECMD_OK			0xFFFFFFF7
#define OPC_FECMD_ATTACHMENT		0xFFFFFFF6
#define OPC_FECMD_DIME_RESPONSE		0xFFFFFFF5

#define OPC_STATE_LASTSTATE		5
#define OPC_STATE_RUNNING		0
#define OPC_STATE_FAILED		1
#define OPC_STATE_NOCONFIG		2
#define OPC_STATE_SUSPENDED		3
#define OPC_STATE_TEST			4
#define OPC_STATE_COMMFAULT		5

#ifdef _OPC_STATE_C
static char *opc_states[OPC_STATE_LASTSTATE+1] = { "running", "failed",
    "noConfig", "suspended", "test", "commFault" };
#endif /* _OPC_REQUESTPROCESS_C */

struct sockaddrT {
    __SOCKADDR_COMMON(sa_);
    char sa_data[max_server_name+16];
};

#define opc_supported_locales_number	50
#define opc_default_locale		"en"
#define opc_default_charset		"UTF-8"

#ifdef _OPC_C
static const char *opc_supported_locales[4]={"en","de","ru",NULL};
#endif /* _OPC_C */

//#define opc_namespace "http://opcfoundation.org/webservices/XMLDA/1.0/"
#define opchdr_namespace "http://ipe.fzk.de/OPCHDRDA/"
#ifdef _OPC_REQUESTPOOL_C
static const char *opc_interfaces[2] = { "XML_DA_Version_1_0", NULL };
static const char *opc_extensions[2][2] = { {"HDR", NULL }, {NULL}};
#endif /* _OPC_REQUESTPOOL_C */

#define OPC_SERVER_CONFIG_MAX_ELEMENTS_RETURNED		4096

typedef void (*DestroyContextFunction)(void *);

#endif /* _OPCCONFIG_H */
