#ifndef _OPCERR_H
#define _OPCERR_H

#define ERR_OPC 0xFFFFF

/**********************************************************************
-----------------------------------------------------------------------
           OPC Warnings                (0x0 - 0xF)                     
-----------------------------------------------------------------------
**********************************************************************/

/**********************************************************************
********** Apache Module ************* (0x3 - 0x4( ********************
**********************************************************************/
#define WRN_OPC_CLI_RECONNECT 0x30000
#define WRN_OPC_CLI_CONNECTED 0x30001


/**********************************************************************
-----------------------------------------------------------------------
           OPC Errors                    (0x10 - 0xFFFF)               
-----------------------------------------------------------------------
**********************************************************************/

/**********************************************************************
********** OPC Server (main) Errors **** (0x10 - 0x1F) ****************
**********************************************************************/

#define ERR_OPC_MEM				0x100000
#define ERR_OPC_NOTFOUND			0x100001
#define ERR_OPC_STACK				0x100002
#define ERR_OPC_PATH				0x100003
#define ERR_OPC_NOTIMPLEMENTED			0x100004
#define ERR_OPC_PARAM				0x100005
#define ERR_OPC_OPTIONS				0x100006
#define ERR_OPC_NOTAVAILABLE			0x100007
#define ERR_OPC_NOTSUPPORTED			0x100008
#define ERR_OPC_NOTAPPLICABLE			0x100009
#define ERR_OPC_BUSY				0x10000A
#define ERR_OPC_LOCK				0x10000B
#define ERR_OPC_NOTINITIALIZED			0x10000C

#define ERR_OPC_LIBRARY_INIT			0x100010

#define ERR_OPC_ERROR_INIT			0x100020

#define ERR_OPC_MALLOC_INIT			0x100030

#define ERR_OPC_FRONTEND_INIT			0x100040
#define ERR_OPC_FRONTEND_THREAD_RETURNCODE	0x100041
#define ERR_OPC_FRONTEND_THREAD_JOIN		0x100043
#define ERR_OPC_FRONTEND_THREAD_CANCELED	0x100044
#define ERR_OPC_FRONTEND_THREAD_RUN		0x100045
#define ERR_OPC_FRONTEND_CHILD_THREAD_JOIN	0x100046
#define ERR_OPC_FRONTEND_CHILD_THREAD_CANCELED	0x100047

#define ERR_OPC_BACKEND_INIT			0x100050
#define ERR_OPC_BACKEND_THREAD_RETURNCODE	0x100051
#define ERR_OPC_BACKEND_THREAD_JOIN		0x100052
#define ERR_OPC_BACKEND_THREAD_CANCELED		0x100053
#define ERR_OPC_BACKEND_THREAD_RUN		0x100054

#define ERR_OPC_THREAD_CANCELED			0x100060
#define ERR_OPC_THREAD_RETURNCODE		0x100061

#define ERR_OPC_BUFFPOOL_INIT			0x100070
#define ERR_OPC_BUFFPOOL_GET			0x100071

#define ERR_OPC_REQUESTPOOL_INIT		0x100080
#define ERR_OPC_REQUEST_INIT			0x100081

#define ERR_OPC_GETTEXT_INIT			0x100090

#define ERR_OPC_PROPERTIES_INIT			0x1000A0
#define ERR_OPC_PROPERTIES_INSTANCE_INIT	0x1000A1
#define ERR_OPC_PROPERTIES_NO_PROPERTY		0x1000A2
#define ERR_OPC_PROPERTIES_UNSERIALIZE		0x1000A3

#define ERR_OPC_PLUGIN_LOAD			0x1000B0
#define ERR_OPC_PLUGIN_INFOFUNCTION		0x1000B1
#define ERR_OPC_PLUGIN_INVALIDINFO		0x1000B2
#define ERR_OPC_PLUGIN_INIT			0x1000B3
#define ERR_OPC_PLUGIN_PATH			0x1000B4

#define ERR_OPC_SIGNALS_INIT			0x1000C0
#define ERR_OPC_SIGNAL_SET_INIT			0x1000C1
#define ERR_OPC_SIGNAL_SET_ADD			0x1000C2
#define ERR_OPC_SIGNAL_MASK_INIT		0x1000C3
#define ERR_OPC_SIGNAL_MASK_SET			0x1000C4
#define ERR_OPC_SIGNAL_ACTION_SET		0x1000C5
#define ERR_OPC_SIGNAL_NOT_SUPPORTED		0x1000C6
#define ERR_OPC_SIGNAL_INIT			0x1000C7
#define ERR_OPC_SIGNAL_EVENT			0x1000C8

#define ERR_OPC_TREE_INIT			0x1000D0

#define ERR_OPC_TRANSLIBRARY_INIT		0x1000E0

#define ERR_OPC_SECLIBRARY_INIT			0x1000F0

/**********************************************************************
********** OPC Frontends Errors ****** (0x100 - 0x1FF) ****************
**********************************************************************/

/********* OPC XML-DA Frontend ******* (0x110 - 0x11F) ***************/
#define ERR_OPC_FE_COMMANDS_INIT	0x1100001
#define ERR_OPC_FE_SCHEMA_PARSE		0x1100002


/* Real Frontend Errors (0x111 - 0x112( */
#define ERR_OPC_FE_MEM 			0x1110000
#define ERR_OPC_FE_OVERLOADED		0x1110001
#define ERR_OPC_FE_CHILDSPAWN		0x1110002

#define ERR_OPC_FE_SOCKET 		0x1110010
#define ERR_OPC_FE_BIND			0x1110011
#define ERR_OPC_FE_LISTEN		0x1110012
#define ERR_OPC_FE_PERMS		0x1110013
#define ERR_OPC_FE_ACCEPT		0x1110014
#define ERR_OPC_FE_SEND			0x1110015
#define ERR_OPC_FE_RECV			0x1110016
#define ERR_OPC_FE_SENDERR		0x1110017
#define ERR_OPC_FE_SELECT		0x1110018
#define ERR_OPC_FE_FCNTL_NONBLOCK	0x1110019
#define ERR_OPC_FE_NETWORK_SOCKET	0x1110020
#define ERR_OPC_FE_NETWORK_BIND		0x1110011
#define ERR_OPC_FE_NETWORK_LISTEN	0x1110012


#define ERR_OPC_FE_CLIREQUEST		0x1110020

/**********************************************************************
********** OPC Backends Errors ******* (0x200 - 0x2FF) ****************
**********************************************************************/
#define ERR_OPC_I_INVALIDSTATE			0x2000000
#define ERR_OPC_I_NOINTERFACES			0x2000001
    
/* Real Backend Errors (0x211 - 0x212( */
#define ERR_OPC_BE_MEM 			0x2110000
#define ERR_OPC_BE_OVERLOADED		0x2110001
#define ERR_OPC_BE_CHILDSPAWN		0x2110002

#define ERR_OPC_BE_SOCKET 		0x2110010
#define ERR_OPC_BE_BIND			0x2110011
#define ERR_OPC_BE_LISTEN		0x2110012
#define ERR_OPC_BE_PERMS		0x2110013
#define ERR_OPC_BE_ACCEPT		0x2110014
#define ERR_OPC_BE_SEND			0x2110015
#define ERR_OPC_BE_RECV			0x2110016
#define ERR_OPC_BE_SENDERR		0x2110017

#define ERR_OPC_BE_SOCKET_NAME_TOO_LONG	0x2110020

/**********************************************************************
********** OPC Library *************** (0x300 - 0x3FF) ****************
**********************************************************************/

/* OPC Library (0x300 - 0x310( */
#define ERR_OPC_LIB_UNKNOWNREQUEST	0x3000000
#define ERR_OPC_LIB_STARTTIME		0x3000001
#define ERR_OPC_LIB_VERSION		0x3000002
#define ERR_OPC_LIB_ITEMNAME		0x3000003

/* OPC Item (0x310 - 0x320( */
#define ERR_OPC_ITEM_INIT		0x3100000
#define ERR_OPC_ITEM_ALREDY_REGISTERED	0x3100001
#define ERR_OPC_ITEM_ALREDY_DESTROYED	0x3100002
#define ERR_OPC_ITEM_CREATE_PATH	0x3100003
#define ERR_OPC_ITEM_HAVE_MANUAL_CHILDS 0x3100004
#define ERR_OPC_ITEM_NOT_LINKED_TO_TREE 0x3100005
#define ERR_OPC_ITEM_FILTERED		0x3100006
#define ERR_OPC_ITEM_NOTFOUND		0x3100007
#define ERR_OPC_ITEM_NOTCONNECTED	0x3100008
#define ERR_OPC_ITEM_MISSINGDATA	0x3100009
#define ERR_OPC_ITEM_CREATE_DATAMANAGER	0x310000A
#define ERR_OPC_ITEM_PARAMS		0x310000B
#define ERR_OPC_ITEM_SERVER_NOTFOUND	0x310000C
#define ERR_OPC_ITEM_SERVER_INCOMPLETE	0x310000D


#define ERR_OPC_ITEM_DATA_CONVERSION		0x3100100
#define ERR_OPC_ITEM_DATA_CONVERSION_FLOAT	0x3100101

#define ERR_OPC_DETERMINE_FLOAT_FORMAT 		0x3100105
#define ERR_OPC_DETERMINE_STRUCT_ALIGN 		0x3100106
#define ERR_OPC_DETERMINE_ALLOCATION_ALIGNMENT	0x3100107

#define ERR_OPC_FORMAT_DESCRIPTION							0x3100110
#define ERR_OPC_FORMAT_DESCRIPTION_OPCBINARY						0x3100111
#define ERR_OPC_FORMAT_DESCRIPTION_OPCBINARY_SCHEMA					0x3100112
#define ERR_OPC_FORMAT_DESCRIPTION_OPCBINARY_DICTIONARY					0x3100120
#define ERR_OPC_FORMAT_DESCRIPTION_OPCBINARY_CREATE					0x310012E
#define ERR_OPC_FORMAT_DESCRIPTION_OPCBINARY_DICTIONARY_PARSE				0x3100121
#define ERR_OPC_FORMAT_DESCRIPTION_OPCBINARY_DICTIONARY_VALIDATE			0x3100122
#define ERR_OPC_FORMAT_DESCRIPTION_OPCBINARY_DICTIONARY_XPATH_CONTEXT			0x3100123
#define ERR_OPC_FORMAT_DESCRIPTION_OPCBINARY_DICTIONARY_XPATH_REGISTER_NAMESPACE	0x3100124
#define ERR_OPC_FORMAT_DESCRIPTION_OPCBINARY_DICTIONARY_FIND_XSI_NAMESPACE		0x3100125
#define ERR_OPC_FORMAT_DESCRIPTION_OPCBINARY_DICTIONARY_INVALID_DICTIONARY		0x3100126
#define ERR_OPC_FORMAT_DESCRIPTION_OPCBINARY_DICTIONARY_UNSUPPORTED_ENDIANESS		0x3100130
#define ERR_OPC_FORMAT_DESCRIPTION_OPCBINARY_DICTIONARY_UNSUPPORTED_FLOATING_FORMAT	0x3100131

#define ERR_OPC_FORMAT_ALREDY_REGISTERED						0x3100127
#define ERR_OPC_FORMAT_INCOMPLETE_FORMAT_STRUCTURE					0x3100128
#define ERR_OPC_FORMAT_INIT_NATIVE							0x3100129
#define ERR_OPC_FORMAT_INIT_OPCXML							0x310012A
#define ERR_OPC_FORMAT_NATIVE_CREATE_INSTANCE						0x310012B
#define ERR_OPC_FORMAT_OPCXML_CREATE_INSTANCE						0x310012C
#define ERR_OPC_FORMAT_MISSING_METHOD_IMPORTDATA					0x310012D
#define ERR_OPC_FORMAT_MISSING_METHOD_READNATIVE					0x3100130
#define ERR_OPC_FORMAT_MISSING_METHOD_WRITENATIVE					0x3100131
#define ERR_OPC_FORMAT_MISSING_METHOD_SEND						0x3100133
#define ERR_OPC_FORMAT_OPCXML_INVALID_OPTIONS						0x3100132
#define ERR_OPC_FORMATS_CREATE_FORMAT_CONTEXT						0x310012E
#define ERR_OPC_FORMATS_HASHTABLE_INSERT						0x310012F

#define ERR_OPC_FORMATS_REGISTER_NATIVE_FORMAT	0x3100140
#define ERR_OPC_FORMATS_REGISTER_OPCXML_FORMAT	0x3100141
/*
#define ERR_OPC_DATA_CREATE_REPRESENTATION 0x3100142
#define ERR_OPC_DATA_CREATE_NATIVE_REPRESENTATION 0x3100143
#define ERR_OPC_DATA_CREATE_OPCXML_REPRESENTATION 0x3100144
#define ERR_OPC_DATA_CREATE_ALLOCATOR_FOR_NATIVE_REPRESENTATION 0x3100145
#define ERR_OPC_DATA_CREATE_ALLOCATOR_FOR_OPCXML_REPRESENTATION 0x3100151
#define ERR_OPC_DATA_DATABUFFER_CREATE	0x3100147
#define ERR_OPC_DATA_NOTINITIALISED 0x31000146
#define ERR_OPC_DATA_INVALID_REPRESENTATION 0x31000150
#define ERR_OPC_DATA_INCOMPLETE_FORMATS_CONTEXT 0x31000148
#define ERR_OPC_DATA_INCOMPLETE_SERVER_CONTEXT 0x31000149
#define ERR_OPC_DATA_REPRESENTATION_INVALID_ALLOCATOR 0x31000152
*/

#define ERR_OPC_DATA_FAST_CREATE_CONTEXT		0x31000169
#define ERR_OPC_DATAFAST_CREATE_ALLOCATOR 		0x31000160
#define ERR_OPC_DATAFAST_INCOMPLETE_FORMATS_CONTEXT 	0x31000161
#define ERR_OPC_DATAFAST_INCOMPLETE_SERVER_CONTEXT 	0x31000162
#define ERR_OPC_DATAFAST_CREATE_LOCK			0x31000163
#define ERR_OPC_DATAFAST_PARAMS				0x31000164
#define ERR_OPC_DATAFAST_OPTIONS			0x31000165
#define ERR_OPC_DATAFAST_ALLOCATOR_BUSY			0x31000166
#define ERR_OPC_DATAFAST_NOTINITIALISED 		0x31000167
#define ERR_OPC_DATAFAST_CREATE_DESTRUCTOR		0x31000168



#define ERR_OPC_DATAREPRESENTATION_CREATE_DATABUFFER 0x3100133
#define ERR_OPC_DATAREPRESENTATION_UNSUPPORTED_FORMAT_TYPE 0x3100132
#define ERR_OPC_DATAREPRESENTATION_UNSUPPORTED_ALLOCATOR_TYPE 0x3100134
#define ERR_OPC_DATAREPRESENTATION_CONVERT 0x3100135
#define ERR_OPC_DATAREPRESENTATION_INCOMPLETE_OPTIONS 0x3100136
#define ERR_OPC_DATAREPRESENTATION_INCOMPLETE_CONTEXT 0x3100137
#define ERR_OPC_DATAREPRESENTATION_DATABUFFER_CREATE 0x3100138
#define ERR_OPC_DATAREPRESENTATION_ALLOCATOR_CREATE 0x3100139
#define ERR_OPC_DATAREPRESENTATION_UNSUPPORTED_ALLOCATOR 0x310013A


#define ERR_OPC_DATA_CREATE_CONTEXT			0x31003120
#define ERR_OPC_DATA_DISABLED_REPRESENTATION		0x31003121
#define ERR_OPC_DATA_MISSING_NATIVE_REPRESENTATION	0x31003118
#define ERR_OPC_DATA_CREATE_NATIVE_REPRESENTATION	0x31003119
#define ERR_OPC_DATA_CREATE_OPCXML_REPRESENTATION	0x3100311A
#define ERR_OPC_DATA_INCOMPLETE_FORMATS			0x3100311B
#define ERR_OPC_DATA_REGISTER_REPRESENTATION_ALREDY	0x3100311C
#define ERR_OPC_DATA_REGISTER_REPRESENTATION_INCOMPLETE	0x3100311D
#define ERR_OPC_DATA_OPTIONS				0x3100311E
#define ERR_OPC_DATA_PARAMS				0x3100311F
#define ERR_OPC_DATA_NOTINITIALIZED			0x31003122

#define ERR_OPC_DATA_BUFFER		0x3100300
#define ERR_OPC_DATA_BUFFER_CREATE	0x3100301
#define ERR_OPC_DATACHUNK		0x3100310
#define ERR_OPC_DATACHUNK_EMPTY		0x3100311
#define ERR_OPC_BUFFERPOOL		0x3100312
#define ERR_OPC_BUFFERPOOL_CREATE	0x3100313
#define ERR_OPC_FORMATS			0x3100314
#define ERR_OPC_FORMATS_CREATE		0x3100315
#define ERR_OPC_PROPERTIES		0x3100316
#define ERR_OPC_PROPERTIES_CREATE	0x3100317
#define ERR_OPC_PROPERTIES_ALREDY_REGISTERED 0x3100320
#define ERR_OPC_PROPERTIES_INVALID_PROPERTY 0x31000321
#define ERR_OPC_PROPERTIES_HASHTABLE_INSERT_FAILED 0x31000322
#define ERR_OPC_PROPERTIES_HASHTABLE_BROKEN 0x31000323
#define ERR_OPC_PROPERTIES_HASHTABLE_INIT 0x3100324
#define ERR_OPC_PROPERTIES_LIMIT_EXCEEDED 0x3100325
#define ERR_OPC_PROPERTIES_ID_ALREDY_USED 0x3100326

#define ERR_OPC_CHUNKPOOL		0x3100318
#define ERR_OPC_CHUNKPOOL_CREATE	0x3100319
#define ERR_OPC_PROPERTY		0x3100330
#define ERR_OPC_PROPERTY_CREATE		0x3100331
#define ERR_OPC_STANDARDTYPE		0x3100334
#define ERR_OPC_STANDARDTYPE_CREATE	0x3100335

#define ERR_OPC_DATABUFFER_OPTIONS							0x3100219
#define ERR_OPC_DATABUFFER_OPTIONS_BUFFERPOOL						0x310021A
#define ERR_OPC_BUFFERPOOL_GET_BUFFER							0x3100210
#define ERR_OPC_DATABUFFER_ALLOCATE_CHUNK						0x3100211
#define ERR_OPC_DATABUFFER_ACCEPT_CHUNK							0x3100212

#define ERR_OPC_ALLOCATOR_INCOMPLETE							0x3100218
#define ERR_OPC_ALLOCATOR_ALLOCATE_CHUNK						0x3100213
#define ERR_OPC_ALLOCATOR_ACCEPT_CHUNK							0x3100214

#define ERR_OPC_CHUNKPOOL_GET_CHUNK							0x3100215

#define ERR_OPC_ITEM_VALUE_OUTOFDATE							0x3100216
#define ERR_OPC_ITEM_VALUE_OUTOFDATE_ACQUIRING						0x3100217

#define ERR_OPC_LOCK_CREATE 0x3100301

//#define ERR_OPC_DATA_CHUNK								0x3100200
//#define ERR_OPC_DATA_ALLOCATE_NEW_CHUNK							0x3100201


#define ERR_OPC_DICTIONARY						0x3100133
#define ERR_OPC_DICTIONARY_PARSE					0x3100134
#define ERR_OPC_DICTIONARY_VALIDATE					0x3100135
#define ERR_OPC_INVALID_ENUMERATION_DESCRIPTION				0x3100135
#define ERR_OPC_FORMAT_DESCRIPTION_OPCBINARY_FORMAT_NOT_SUPPORTED	0x3100136
#define ERR_OPC_TYPE_UNSUPPORTED					0x3100137
#define ERR_OPC_TYPE_UNSUPPORTED_BY_FORMAT				0x3100138
#define ERR_OPC_TYPE_CONVERSION_FAILED					0x3100139
#define ERR_OPC_TYPE_UNSUPPORTED_CONFIGURATION				0x310013A
#define ERR_OPC_TYPE_INVALID_SIZE					0x310013B



/* Supporting tools (0x3F0 - 0x3FFF) */
/*  OPC Holder (0x3F0 - 0x3F1) */
#define ERR_OPC_HOLDER_BUSY		0x3F10000

/**********************************************************************
********** XML Library *************** (0x400 - 0x4FF) ****************
**********************************************************************/
/* XML Library (0x400 - 0x410( */
#define ERR_OPC_XLIB_CREATEPARSER 	0x4000000
#define ERR_OPC_XLIB_CHUNKSMALL 	0x4000001
#define ERR_OPC_XLIB_CHUNKBIG 		0x4000002

#define ERR_OPC_XLIB_PARSEREQUEST	0x4000100
#define ERR_OPC_XLIB_REQUESTEMPTY	0x4000101
#define ERR_OPC_XLIB_NSNOTFOUND		0x4000102

#define ERR_OPC_XLIB_INVALID_BROWSE_FILTER		0x4000200
#define ERR_OPC_XLIB_INVALID_RETURNED_ELEMENTS_NUMBER	0x4000201
#define ERR_OPC_XLIB_INVALID_CONTINUATION_POINT		0x4000202
#define ERR_OPC_XLIB_CONTINUATION_POINT_BROWSE_FILTER	0x4000203
#define ERR_OPC_XLIB_CONTINUATION_POINT_NAME_FILTER	0x4000204
#define ERR_OPC_XLIB_CONTINUATION_POINT_VENDOR_FILTER	0x4000205
#define ERR_OPC_XLIB_CONTINUATION_POINT_ITEMNAME	0x4000206
#define ERR_OPC_XLIB_SERIALIZE_INIT			0x4000207
#define ERR_OPC_XLIB_SERIALIZE				0x4000208
#define ERR_OPC_XLIB_SERIALIZE_FINALIZE			0x4000209

/* XML Security Library (0x410 - 0x420( */

/* Error Responses from OPCInterface (0x4A0 - 0x4B0( */
#define ERR_OPC_XLIB_SERVER_TREE			0x4A00300
#define ERR_OPC_XLIB_NO_MORE_ITEMS			0x4A00301
#define ERR_OPC_XLIB_MORE_ITEMS				0x4A00302



/**********************************************************************
********** Apache Module ************* (0x500 - 0x5FF) ****************
**********************************************************************/
#define ERR_OPC_CLI_MEM 		0x5000000
#define ERR_OPC_CLI_APACHE		0x5000001
#define ERR_OPC_CLI_SRVNOTFOUND 	0x5000010
#define ERR_OPC_CLI_SOCKET 		0x5000011
#define ERR_OPC_CLI_BIND 		0x5000012
#define ERR_OPC_CLI_CONNECT 		0x5000013
#define ERR_OPC_CLI_UNDERSTAND		0x5000014
#define ERR_OPC_CLI_BUSY		0x5000015
#define ERR_OPC_CLI_SEND		0x5000020
#define ERR_OPC_CLI_RECV		0x5000021
#define ERR_OPC_CLI_SRVRESPONSE		0x5000030
#define ERR_OPC_CLI_XMLREQUEST		0x5000031
#define ERR_OPC_CLI_SRVINITRC		0x5000032
#define ERR_OPC_CLI_SRVINTERNAL		0x5000033

#endif /* _OPCERR_H */
