#ifndef _OPC_ALLOCATOR_SIMPLE_H
#define _OPC_ALLOCATOR_SIMPLE_H

#include <opcallocator.h>

typedef struct OPCAllocatorSimpleContextT *OPCAllocatorSimpleContext;
typedef struct OPCAllocationSimpleT *OPCAllocationSimple;

struct OPCAllocationSimpleT {
    OPCAllocation allocation;
    char *buffer;
    char *prebuffer;
    unsigned long current_size;
    unsigned long buffer_size;
};

struct OPCAllocatorSimpleContextT {
    struct OPCAllocatorContextT base;
};


OPCAllocator opcAllocatorSimple();


OPCAllocatorSimpleContext opcAllocatorSimpleCreateContext(OPCMallocContext mctx);
int opcAllocatorSimpleInitContext(OPCAllocatorSimpleContext ctx, const void *options);
void opcAllocatorSimpleFreeContext(OPCAllocatorSimpleContext ctx);

OPCAllocation opcAllocatorSimpleStart(OPCAllocatorSimpleContext ctx, unsigned long preallocate);
void *opcAllocatorSimpleAllocateMemory(OPCAllocatorSimpleContext ctx, OPCAllocation allocation, unsigned long size, unsigned char alignment);
void *opcAllocatorSimpleAcceptChunk(OPCAllocatorSimpleContext ctx, OPCAllocation allocation, unsigned long *size);
void opcAllocatorSimpleCancelChunk(OPCAllocatorSimpleContext ctx, OPCAllocation allocation);
OPCAllocation opcAllocatorSimpleAccept(OPCAllocatorSimpleContext ctx, OPCAllocation allocation);
void opcAllocatorSimpleCancel(OPCAllocatorSimpleContext ctx, OPCAllocation allocation);
void opcAllocatorSimpleFree(OPCAllocatorSimpleContext ctx, OPCAllocation allocation);
void *opcAllocatorSimpleAllocateChunk(OPCAllocatorSimpleContext ctx, OPCAllocation allocation, unsigned long size);
OPCAllocation opcAllocatorSimpleAllocateSimple(OPCAllocatorSimpleContext ctx, unsigned long size);
void* opcAllocatorSimpleGet(OPCAllocatorSimpleContext ctx, OPCAllocation allocation, unsigned long *size);
void* opcAllocatorSimpleGetNext(OPCAllocatorSimpleContext ctx, OPCAllocation allocation, void *current, unsigned long *size);
int opcAllocatorSimpleCall(OPCAllocatorSimpleContext ctx, OPCAllocation allocation, OPCSendFunction func, void *attr, unsigned char align);
unsigned long opcAllocatorSimpleSizeof(OPCAllocatorSimpleContext ctx, OPCAllocation allocation, unsigned char align);

#ifdef _OPC_ALLOCATOR_SIMPLE_C
static const struct OPCAllocatorT opc_allocator_simple = {
    "Simple",
    (OPCAllocatorCreateFunction)opcAllocatorSimpleCreateContext,
    (OPCAllocatorInitFunction)opcAllocatorSimpleInitContext,
    (OPCAllocatorFreeFunction)opcAllocatorSimpleFreeContext,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    (OPCAllocatorStartAllocationFunction)opcAllocatorSimpleStart,
    (OPCAllocatorAllocateMemFunction)opcAllocatorSimpleAllocateMemory,
    (OPCAllocatorFreeMemFunction)opcAllocatorSimpleFree,
    (OPCAllocatorAcceptChunkFunction)opcAllocatorSimpleAcceptChunk,
    (OPCAllocatorCancelChunkFunction)opcAllocatorSimpleCancelChunk,
    (OPCAllocatorAcceptFunction)opcAllocatorSimpleAccept,
    (OPCAllocatorCancelFunction)opcAllocatorSimpleCancel,
    (OPCAllocatorAllocateSimpleChunkFunction)opcAllocatorSimpleAllocateChunk,
    (OPCAllocatorAllocateSimpleFunction)opcAllocatorSimpleAllocateSimple,
    NULL,
    NULL,
    (OPCAllocatorGetFunction)opcAllocatorSimpleGet,
    (OPCAllocatorGetNextFunction)opcAllocatorSimpleGetNext,
    (OPCAllocatorCallFunction)opcAllocatorSimpleCall,
    (OPCAllocatorSizeofFunction)opcAllocatorSimpleSizeof
};

#endif /* _OPC_ALLOCATOR_SIMPLE_C */

#endif /* _OPC_ALLOCATOR_SIMPLE_H */

