#ifndef _OPC_BUFFER_POOL_H
#define _OPC_BUFFER_POOL_H

#include <opcmalloc.h>
#include <lock.h>

typedef struct OPCBufferPoolContextT *OPCBufferPoolContext;

#include <opcbuffer.h>

/*
    Buffer size should be multiple of align_allocation!
*/

struct OPCBufferPoolContextT {
    OPCMallocContext malloc;
    
    LockContext lock;
    
    unsigned long bins;
    OPCBufferContext *first;
    OPCBufferContext *last;
    unsigned long *allocated;
    
    unsigned char lsr;
};

OPCBufferPoolContext opcBufferPoolCreateContext(OPCMallocContext mctx);
int opcBufferPoolInitContext(OPCBufferPoolContext ctx, unsigned long first_bin, unsigned char bins);
void opcBufferPoolFreeContext(OPCBufferPoolContext ctx);
void opcBufferPoolDestroyContext(OPCBufferPoolContext ctx);


OPCBufferContext opcBufferPoolGetBuffer(OPCBufferPoolContext ctx, unsigned long size);
void opcBufferPoolReturnBuffer(OPCBufferPoolContext ctx, OPCBufferContext buffer);
int opcBufferPoolResizeBuffer(OPCBufferPoolContext ctx, OPCBufferContext buffer, unsigned long size);
int opcBufferPoolReplaceBuffer(OPCBufferPoolContext ctx, OPCBufferContext buffer, unsigned long size);
void opcBufferPoolMantain(OPCBufferPoolContext ctx);

#endif /* _OPC_BUFFER_POOL_H */
