#ifndef _OPC_HOLDER_H
#define _OPC_HOLDER_H

#include <lock.h>
#include <condition.h>
#include <opcmalloc.h>
#include <doublehash.h>

#include <opcholderbucket.h>

typedef struct OPCHolderContextT *OPCHolderContext;

struct OPCHolderContextT {
    OPCMallocContext malloc;
    DoubleHashContext double_hash;
    LockContext lock;
    ConditionContext cond;
    
    unsigned long max_size;
    time_t timeout;
};

OPCHolderContext opcHolderCreateContext(OPCMallocContext mctx);
int opcHolderInitContext(OPCHolderContext ctx, unsigned long size);
void opcHolderFreeContext(OPCHolderContext ctx);
void opcHolderDestroyContext(OPCHolderContext ctx);
void opcHolderMantain(OPCHolderContext ctx);

void opcHolderSetMaxSize(OPCHolderContext ctx, unsigned long max_size);
void opcHolderSetTimeout(OPCHolderContext ctx, time_t timeout);

unsigned long opcHolderPut(OPCHolderContext ctx, OPCHolderBucketContext bucket);
OPCHolderBucketContext opcHolderGet(OPCHolderContext ctx, unsigned long pos, unsigned long magic, unsigned long secret);
const void* opcHolderGetLink(OPCHolderContext ctx, unsigned long pos, unsigned long magic, unsigned long secret);
void opcHolderReturnLink(OPCHolderContext ctx, unsigned long pos);

#endif /* _OPC_HOLDER_H */
