#ifndef _OPC_HOLDER_BUCKET_H
#define _OPC_HOLDER_BUCKET_H

#include <opcconfig.h>

#include <lock.h>
#include <time.h>
#include <opcmalloc.h>

struct OPCHolderBucketContextT {
    void *data;
    time_t destruction_time;
    time_t step_time;
    DestroyContextFunction destructor;
    OPCMallocContext malloc;
    LockContext lock;
    unsigned long magic;
    unsigned long secret;
};

typedef struct OPCHolderBucketContextT *OPCHolderBucketContext;

OPCHolderBucketContext opcHolderBucketInitContext(OPCMallocContext mctx, void *ptr, time_t lifetime, time_t steptime, DestroyContextFunction destructor);
void opcHolderBucketDestroyContext(OPCHolderBucketContext ctx);

void opcHolderBucketLock(OPCHolderBucketContext ctx);
void opcHolderBucketUnlock(OPCHolderBucketContext ctx);
void opcHolderBucketRestartTimer(OPCHolderBucketContext ctx);

int opcHolderBucketMantain(OPCHolderBucketContext ctx, void *attr);

int opcHolderBucketSetNumbers(OPCHolderBucketContext ctx, unsigned long magic);
int opcHolderBucketCheckMagicNumber(OPCHolderBucketContext ctx, unsigned long magic);
int opcHolderBucketCheckSecretNumber(OPCHolderBucketContext ctx, unsigned long secret);

#define OPC_HOLDER_BUCKET_MAGIC_REQUEST_BROWSE 1



#endif /* _OPC_HOLDER_BUCKET_H */
