#ifndef _OPC_H
#define _OPC_H

typedef struct OPCContextT *OPCContext;

#include <opcmalloc.h>

#include <opctime.h>
#include <opcversion.h>
#include <opcstate.h>
#include <opclocales.h>
#include <opcproperties.h>
#include <opctree.h>
#include <opcholder.h>
#include <opcconfiguration.h>

#include <opcfdopcbinary.h>
#include <opcformats.h>
#include <opcchunkpool.h>
#include <opcbufferpool.h>

struct OPCContextT {
    OPCMallocContext malloc;
    OPCState state;
    OPCVersion version;
    OPCTime start_time;
    OPCLocalesContext locales;
    OPCTreeContext tree;
    OPCHolderContext holder;


    OPCFDOPCBinaryContext fd_opcbinary;
    OPCFormatsContext formats;
    OPCChunkPoolContext chunks;
    OPCBufferPoolContext buffers;
    OPCPropertiesContext properties;
    
    OPCConfigurationContext config;
};

int opcInit();
void opcDestroy();

OPCContext opcCreateContext(OPCMallocContext malloc);
int opcInitContext(OPCContext ctx, OPCConfigurationContext cfg, unsigned long scalbility);
void opcFreeContext(OPCContext ctx);
void opcDestroyContext(OPCContext ctx);
void opcMantain(OPCContext ctx);

#endif /* _OPC_H */
