#ifndef _OPC_FORMATS_H
#define _OPC_FORMATS_H

#include <opcmalloc.h>
#include <opcformatnative.h>
#include <hashtable.h>
#include <opcconfiguration.h>

typedef struct OPCFormatsContextT *OPCFormatsContext;

struct OPCFormatsContextT {
    OPCMallocContext malloc;
    OPCFormatNativeContext native_format;
    OPCFormatContext binary_format;
    OPCFormatContext opcxml_format;
    HashTable formats;
    unsigned int max_formats;
    unsigned int registered_formats;
};

OPCFormatsContext opcFormatsCreateContext(OPCMallocContext mctx);
int opcFormatsInitContext(OPCFormatsContext ctx, OPCConfigurationContext config);
void opcFormatsFreeContext(OPCFormatsContext ctx);
void opcFormatsDestroyContext(OPCFormatsContext ctx);

OPCFormatContext opcFormatsFindFormat(OPCFormatsContext ctx, const char *format);
OPCFormatContext opcFormatsRegisterFormat(OPCFormatsContext ctx, OPCFormatContext fctx, const void *options);
/* ToDo: opcFormatsRemoveFormat(Ref,Unref CreateContext and RegisterFormat ref)? */

#endif /* _OPC_FORMATS_H */

