#include <opcerr.h>
#include <opcassert.h>
#include <opcdebug.h>

#include <opcitemproperties.h>

void opcItemPropertiesZeroContext(OPCItemPropertiesContext ctx) {
    assert(ctx);
    
    ctx->properties=NULL;
    ctx->relocation=NULL;
}

OPCItemPropertiesContext opcItemPropertiesCreateContext(OPCMallocContext mctx) {
    OPCItemPropertiesContext ctx;

    opcDebugServer(OPC_DEBUG_DEBUG, "opcItemPropertiesCreateContext");    

    ctx = (OPCItemPropertiesContext)opcMalloc(mctx,sizeof(struct OPCItemPropertiesContextT));
    if (ctx) {
	ctx->malloc=mctx;
	opcItemPropertiesZeroContext(ctx);
	
    }
    return ctx;
}

int opcItemPropertiesInitContext(OPCItemPropertiesContext ctx, unsigned short properties_maxid) {
    unsigned short i;
    
    assert(ctx);
    
    ctx->properties = (OPCItemPropertyContext*)opcMalloc(ctx->malloc, properties_maxid*sizeof(OPCItemPropertyContext));
    if (!ctx->properties) return ERR_OPC_MEM;
    
    for (i=0;i<properties_maxid;i++)
	ctx->properties[i]=NULL;

    return 0;
}

int opcItemPropertiesInitLimitedContext(OPCItemPropertiesContext ctx, unsigned short size, unsigned short *relocation) {
    assert(ctx);
    
    ctx->relocations = size;
    ctx->relocation = relocation;
    
    return opcItemPropertiesInitContext(ctx, size);
}

void opcItemPropertiesFreeContext(OPCItemPropertiesContext ctx) {
    opcDebugServer(OPC_DEBUG_NOTICE, "opcItemPropertiesFreeContext");    

    assert(ctx);

    if (ctx->properties) opcFree(ctx->malloc, ctx->properties);
    opcItemPropertiesZeroContext(ctx);
}

void opcItemPropertiesDestroyContext(OPCItemPropertiesContext ctx) {
    opcDebugServer(OPC_DEBUG_NOTICE, "opcItemPropertiesDestroyContext");    

    opcItemPropertiesFreeContext(ctx);
    opcFree(ctx->malloc,ctx);
}

/*
OPCPropertyContext opcItemPropertiesCreateProperty(OPCItemPropertiesContext ctx, OPCPropertyContext prop) {
}

opcItemPropertiesDestroyProperty(OPCItemPropertiesContext ctx, OPCItemPropertyContext iprop) {
}

*/
