#ifndef _OPC_LOCALES_H
#define _OPC_LOCALES_H

#include <lock.h>
#include <hashtable.h>
#include <opclocale.h>
#include <opcmalloc.h>


struct OPCLocalesContextT {
    OPCMallocContext malloc;
    HashTable locales;
    LockContext lock;
};

typedef struct OPCLocalesContextT *OPCLocalesContext;

typedef int (*OPCLocalesListFunctionT)(const char *, void*);

OPCLocalesContext opcLocalesCreateContext(OPCMallocContext mctx);
int opcLocalesInitContext(OPCLocalesContext ctx);
void opcLocalesFreeContext(OPCLocalesContext ctx);
void opcLocalesDestroyContext(OPCLocalesContext ctx);

int opcLocalesAddLocale(OPCLocalesContext ctx, const char *newlocale);
int opcLocalesAddLocales(OPCLocalesContext ctx, const char **newlocales);
OPCLocale opcLocalesGetLocale(OPCLocalesContext ctx, char *attr);
int opcLocalesList(OPCLocalesContext ctx, OPCLocalesListFunctionT list_function, void *attr);


#endif /* _OPC_LOCALE_H */
