#define _OPC_STANDARD_PROPERTIES_C

#include <opcassert.h>
#include <opcerr.h>

#include <opcstandardproperties.h>

int opcPropertiesRegisterStandard(OPCPropertiesContext ctx) {
    int err;
    OPCPropertyContext prop;
    OPCStandardProperty pctx;
    
    assert(ctx);
    
    for (pctx=opc_property;pctx->name;pctx++) {
	prop = opcPropertyCreateContext(ctx->malloc);
	if (!prop) return ERR_OPC_PROPERTY_CREATE;
	err = opcPropertyInitContext(prop,pctx->name, pctx->type, pctx->attr);
	if (err) {
	    opcPropertyDestroyContext(prop);
	    return err;
	}
	opcPropertySetId(prop,pctx->id);
	if (pctx->xmlnamespace) opcPropertySetNamespace(prop,pctx->xmlnamespace);
	if (pctx->description) opcPropertySetDescription(prop,pctx->description);
	
	err = opcPropertiesRegisterProperty(ctx, prop);
	if (err) {
	    opcPropertyDestroyContext(prop);
	    return err;
	}
    }
    return 0;
}
