#ifndef _OPC_STATE_H
#define _OPC_STATE_H

typedef struct OPCStateT *OPCState;

#include <lchar.h>
#include <lock.h>
#include <opc.h>
#include <opcmalloc.h>

struct OPCStateT {
    OPCMallocContext malloc;
    LockContext lock;
    unsigned int state;
    lchar status_info;
    lchar vendor_info;
};

OPCState opcStateCreate(OPCMallocContext mctx);
int opcStateInit(OPCState ctx, OPCContext sctx);
void opcStateFree(OPCState ctx);
void opcStateDestroy(OPCState ctx);

int opcStateSetStatus(OPCState ctx, unsigned int state, const char *status);
int opcStateSetVendor(OPCState ctx, const char *vendor);

const lchar opcStateGetStatusInfo(OPCState ctx, const char *locale);
const lchar opcStateGetVendorInfo(OPCState ctx, const char *locale);
const lchar opcStateGetStatus(OPCState ctx, const char *locale);

#endif /* _OPC_STATE_H */
