#ifndef _OPC_VERSION_H
#define _OPC_VERSION_H

#include <opcstringlist.h>
#include <opcmalloc.h>

typedef struct OPCVersionT *OPCVersion;
typedef struct OPCInterfaceVersionT *OPCInterfaceVersion;

#include <opc.h>

struct OPCInterfaceVersionT {
    const char *interface;
    const char **extensions;
};

struct OPCVersionT {
    OPCMallocContext malloc;
    
    char *major;
    char *minor;
    unsigned long build;
    char *version;
    OPCStringList SupportedInterfaceVersions;
};

typedef int (*OPCVersionListFunctionT)(const char *, void*);

OPCVersion opcVersionInit(OPCMallocContext mctx, OPCContext ctx);
void opcVersionDestroy(OPCVersion ctx);
int opcVersionSet(OPCVersion ctx, const char *major, const char *minor, unsigned long build);
void opcVersionInterfacesClear(OPCVersion ctx);
int opcVersionInterfaceAdd(OPCVersion ctx, const char *interface, const char **extensions);

const char *opcVersionGet(OPCVersion ctx);
int opcVersionList(OPCVersion ctx, OPCVersionListFunctionT list_function, void *attr);

#endif /* _OPC_VERSION_H */
