#define _OPC_FORMAT_NATIVE_C
#include <assert.h>

#include <opcerr.h>

#include <opcformatnative.h>

OPCFormatContext opcFormatNative() {
    return (OPCFormatContext)&opc_format_native;
}

/*
OPCFormatContext opcFormatNativeCreateContext(OPCMallocContext mctx) {
    OPCFormatContext ctx;

    ctx = (OPCFormatContext)opcMalloc(mctx,sizeof(struct OPCFormatNativeContextT));
    if (ctx) {
	memcpy(ctx,&opc_format_native,sizeof(opc_format_native));
	ctx->malloc=mctx;
    }
    return ctx;
}


static inline void opcFormatNativeInstanceZeroContext(OPCFormatNativeInstanceContext ctx) {
    assert(ctx);
    
    ctx->data = NULL;
}

OPCFormatInstanceContext opcFormatNativeInstanceCreateContext(OPCFormatContext format) {
    OPCFormatInstanceContext ctx;
    
    assert(format);

    ctx = (OPCFormatInstanceContext)opcMalloc(format->malloc,sizeof(struct OPCFormatNativeInstanceContextT));
    if (ctx) {
	ctx->malloc=format->malloc;
	ctx->format=format;
	opcFormatNativeInstanceZeroContext((OPCFormatNativeInstanceContext)ctx);
    }
    return ctx;
}

int opcFormatNativeInstanceInitContext(OPCFormatInstanceContext ctx, const OPCFormatNativeOptionsContext options) {
    int err;
    unsigned long buffer_initial_size; 
    
//    OPCFormatNativeInstanceContext fi = (OPCFormatNativeInstanceContext)ctx;
    OPCDataBufferContext data;
    
    assert(ctx);
    
    opcFormatNativeInstanceZeroContext((OPCFormatNativeInstanceContext)ctx);

    data = opcDataBufferCreateContext(ctx->malloc);
    if (!data) return ERR_OPC_DATA_BUFFER_CREATE;
    
    if (options) buffer_initial_size = options->buffer_initial_size;
    else buffer_initial_size = 0;
    
    err = opcDataBufferInitContext(data, ctx->format->buffer_pool, buffer_initial_size);
    if (err) {
	opcDataBufferDestroyContext(data);
	return err;
    }
    
    ((OPCFormatNativeInstanceContext)ctx)->data = data;
    
    return 0;
}

void opcFormatNativeInstanceFreeContext(OPCFormatInstanceContext ctx) {
    assert(ctx);

    if (((OPCFormatNativeInstanceContext)ctx)->data) 
	opcDataBufferDestroyContext(((OPCFormatNativeInstanceContext)ctx)->data);
	
    opcFormatNativeInstanceZeroContext((OPCFormatNativeInstanceContext)ctx);
}

void opcFormatNativeInstanceDestroyContext(OPCFormatInstanceContext ctx) {
    opcFormatNativeInstanceFreeContext(ctx);
    assert(ctx->format);
    opcFree(ctx->format->malloc, ctx);
}

*/

int opcFormatNativeImportData(OPCFormatNativeContext ctx, OPCType type, OPCAllocatorContext allocator, OPCData data, const void *buffer, unsigned long size) {
    OPCAllocation allocation;
    void *ptr;
    
    assert(ctx);
    assert(type);
    assert(data);
    assert(buffer);
    assert(allocator);

    if ((!size)&&(type->size)) size=type->size;

    if (size) {
	allocation=opcAllocatorSimpleAllocate(allocator,size);
	if (allocation) ptr = opcAllocatorGet(allocator,allocation,NULL);
	else return ERR_OPC_ALLOCATOR_ALLOCATE_CHUNK;
	memcpy(ptr, buffer, size);
	data->data=(void*)allocation;
	data->size = opcAllocatorSizeof(allocator,allocation,1);
	data->type = OPC_DATA_TYPE_ALLOCATION;
	return 0;
    } else {
	// ToDo: go by items
    }
    return ERR_OPC_NOTIMPLEMENTED;
}
