#ifndef _OPC_FORMAT_NATIVE_H
#define _OPC_FORMAT_NATIVE_H

#include <opctype.h>
#include <opcallocator.h>
#include <opcformat.h>
#include <opcdatabuffer.h>

typedef struct OPCFormatNativeContextT *OPCFormatNativeContext;
//typedef struct OPCFormatNativeInstanceContextT *OPCFormatNativeInstanceContext;
//typedef struct OPCFormatNativeOptionsContextT *OPCFormatNativeOptionsContext;

struct OPCFormatNativeContextT {
    struct OPCFormatContextT format;
};


int opcFormatNativeImportData(OPCFormatNativeContext ctx, OPCType type, OPCAllocatorContext allocator, OPCData data, const void *buffer, unsigned long size);

OPCFormatContext opcFormatNative();


#ifdef _OPC_FORMAT_NATIVE_C
struct OPCFormatNativeContextT opc_format_native = {
    {
	"Native",
	OPC_FORMAT_TYPE_NATIVE,
	OPC_ALLOCATOR_TYPE_FULL,
	NULL,
	NULL,								/* InitContext */
	NULL,								/* FreeContext */
	NULL,								/* DestroyContext */
	(OPCFormatImportDataFunction)opcFormatNativeImportData,		/* ImportData */
	NULL,								/* FreeData */
	NULL,								/* ReadNative */
	NULL,								/* WriteNative */
	NULL,								/* Send */
	NULL,
	NULL
    }
};
#endif /* _OPC_FORMAT_NATIVE_C */


#endif /* _OPC_FORMAT_NATIVE_H */
