#ifndef _OPC_FORMAT_OPCXML_H
#define _OPC_FORMAT_OPCXML_H

#include <libxml/tree.h>

#include <opcformat.h>

typedef struct OPCConversionOPCXMLT *OPCConversionOPCXML;
typedef struct OPCFormatOPCXMLContextT *OPCFormatOPCXMLContext;

struct OPCConversionOPCXMLT {
    xmlNodePtr node;
    xmlNsPtr xsins;
};

struct OPCFormatOPCXMLContextT {
    struct OPCFormatContextT format;
    xmlNsPtr opcns;
    xmlNsPtr xsins;
};

OPCFormatContext opcFormatOPCXML();


int opcFormatOPCXMLFree(OPCFormatOPCXMLContext ctx, OPCType type, OPCAllocatorContext allocator, OPCData data);
int opcFormatOPCXMLReadNative(OPCFormatOPCXMLContext ctx, OPCType type, OPCAllocatorContext allocator, OPCData data, OPCData native);
int opcFormatOPCXMLWriteNative(OPCFormatOPCXMLContext ctx, OPCType type, OPCAllocatorContext allocator, OPCData native, OPCData data);

int opcFormatOPCXMLWriteInteger(OPCFormatOPCXMLContext ctx, OPCType type, OPCConversionOPCXML conversion, const void *source, unsigned long *bytes);
int opcFormatOPCXMLWriteFloat(OPCFormatOPCXMLContext ctx, OPCType type, OPCConversionOPCXML conversion, const void *source, unsigned long *bytes);

#ifdef _OPC_FORMAT_OPCXML_C
struct OPCFormatOPCXMLContextT opc_format_opcxml = {
    {
	"OPCXML",
	OPC_FORMAT_TYPE_OPCXML,
	OPC_ALLOCATOR_TYPE_ABSENT,
	NULL,
	NULL,								/* InitContext */
	NULL,								/* FreeContext */
	NULL,								/* DestroyContext */
	NULL,								/* ImportData */
	(OPCFormatFreeDataFunction)opcFormatOPCXMLFree,
	(OPCFormatReadNativeFunction)opcFormatOPCXMLReadNative,
	(OPCFormatWriteNativeFunction)opcFormatOPCXMLWriteNative,
	NULL,								/* Send */
	(OPCFormatWriteIntegerFunction)opcFormatOPCXMLWriteInteger,
	(OPCFormatWriteFloatFunction)opcFormatOPCXMLWriteFloat
    }
};
#endif /* _OPC_FORMAT_NATIVE_C */

#endif /* _OPC_FORMAT_OPCXML_H */
