#ifndef _OPC_FORMAT_DESCRIPTION_OPC_BINARY_H
#define _OPC_FORMAT_DESCRIPTION_OPC_BINARY_H

#include <libxml/tree.h>
#include <libxml/xmlschemas.h>


#include <opcmalloc.h>
#include <lock.h>

#include <opcconfiguration.h>

typedef struct OPCFDOPCBinaryContextT *OPCFDOPCBinaryContext;

#include <opcfdopcbinarydictionary.h>


struct OPCFDOPCBinaryContextT {
    OPCMallocContext malloc;
    OPCNamespaces namespaces;

    LockContext lock;
    
    char *dictdir;
    unsigned long dictdir_chars;
    
    xmlSchemaParserCtxtPtr schema_parser;
    xmlSchemaPtr schema_rep;
    xmlSchemaValidCtxtPtr schema_ctx;
};

OPCFDOPCBinaryContext opcFDOPCBinaryCreateContext(OPCMallocContext mctx);
int opcFDOPCBinaryInitContext(OPCFDOPCBinaryContext ctx, OPCNamespaces namespaces, const char *schema, const char *dictdir);
void opcFDOPCBinaryFreeContext(OPCFDOPCBinaryContext ctx);
void opcFDOPCBinaryDestroyContext(OPCFDOPCBinaryContext ctx);

int opcFDOPCBinaryValidateXML(OPCFDOPCBinaryContext ctx, xmlDocPtr doc);
int opcFDOPCBinaryValidateDictionary(OPCFDOPCBinaryContext ctx, OPCFDOPCBinaryDictionaryContext dctx);
OPCFDOPCBinaryDictionaryContext opcFDOPCBinaryCreateDictionaryFromMemory(OPCFDOPCBinaryContext ctx, const char *xml, unsigned long length);
OPCFDOPCBinaryDictionaryContext opcFDOPCBinaryCreateDictionary(OPCFDOPCBinaryContext ctx, const char *dictionary);

#endif /* _OPC_FORMAT_DESCRIPTION_OPC_BINARY_H */
