#include <assert.h>

#include <opcsimpletypes.h>

OPCTypeInteger opcTypeIntegerInit(OPCMallocContext mctx, unsigned char is_signed, unsigned char bytes, OPCByteOrder byte_order) {
    OPCTypeInteger ctx;
    
    ctx = (OPCTypeInteger)opcMalloc(mctx, sizeof(struct OPCTypeIntegerT));
    if (!ctx) return ctx;
    
    ((OPCTreeNodeContext)ctx)->malloc=mctx;
    opcTypeInit((OPCType)ctx, OPC_TYPE_INTEGER, NULL);

    ctx->is_signed = is_signed;
    ctx->bytes = bytes;
    ctx->byte_order = byte_order;
    ctx->base.size = bytes;
    return ctx;
}

OPCTypeFloat opcTypeFloatInit(OPCMallocContext mctx, OPCFloatFormat format, unsigned char bytes, OPCByteOrder byte_order) {
    OPCTypeFloat ctx;
    
    ctx = (OPCTypeFloat)opcMalloc(mctx, sizeof(struct OPCTypeFloatT));
    if (!ctx) return ctx;
    
    ((OPCTreeNodeContext)ctx)->malloc=mctx;
    opcTypeInit((OPCType)ctx, OPC_TYPE_FLOAT, NULL);

    ctx->bytes = bytes;
    ctx->byte_order = byte_order;
    ctx->float_format = format;
    ctx->base.size = bytes;
    return ctx;
}



/*
struct OPCTypeIntegerT {
    struct OPCTypeT base;
    OPCByteOrder byte_order;
    unsigned char bytes;
};

struct OPCTypeFloatT {
    struct OPCTypeT base;
    OPCFloatFormat float_format;
    OPCByteOrder byte_order;
    unsigned char bytes;
};
*/
