#ifndef _OPC_SIMPLE_TYPES_H
#define _OPC_SIMPLE_TYPES_H

#include <opctype.h>

typedef enum OPCByteOrderT OPCByteOrder;
typedef enum OPCFloatFormatT OPCFloatFormat;

enum OPCByteOrderT {
    OPC_LITTLE_ENDIAN = 0,
    OPC_BIG_ENDIAN,
    OPC_MIXED_ENDIAN
};

enum OPCFloatFormatT {
    OPC_FLOAT_IEEE = 0
};



typedef struct OPCTypeIntegerT *OPCTypeInteger;
typedef struct OPCTypeFloatT *OPCTypeFloat;
//typedef struct OPCTypeComplexT *OPCTypeComplex;

struct OPCTypeIntegerT {
    struct OPCTypeT base;
    unsigned char is_signed;
    OPCByteOrder byte_order;
    unsigned char bytes;
};

struct OPCTypeFloatT {
    struct OPCTypeT base;
    OPCFloatFormat float_format;
    OPCByteOrder byte_order;
    unsigned char bytes;
};

OPCTypeInteger opcTypeIntegerInit(OPCMallocContext mctx, unsigned char is_signed, unsigned char bytes, OPCByteOrder byte_order);
OPCTypeFloat opcTypeFloatInit(OPCMallocContext mctx, OPCFloatFormat format, unsigned char bytes, OPCByteOrder byte_order);

#endif /* _OPC_SIMPLE_TYPES_H */
