#ifndef _OPC_TYPE_H
#define _OPC_TYPE_H

#include <opclib.h>
#include <opctreenode.h>

typedef void *OPCConversion;
typedef struct OPCTypeT *OPCType;

#include <opcformat.h>

typedef enum OPCTypeOptionsT OPCTypeOptions;
typedef enum OPCSimpleTypeT OPCSimpleType;

enum OPCSimpleTypeT {
    OPC_TYPE_COMPLEX = 0,
    OPC_TYPE_ALIGN,
    OPC_TYPE_INTEGER,
    OPC_TYPE_FLOAT
};

enum OPCTypeOptionsT {
    OPC_TYPE_OPTION_MASTER = 1
};

/*
#define OPC_TYPE_STRING		1
#define OPC_TYPE_STRINGLIST	2
#define OPC_TYPE_URL		3
#define OPC_TYPE_QNAME		4
#define OPC_TYPE_BASE64		5
#define OPC_TYPE_ENUMERATION	6
#define OPC_TYPE_DATETIME	7
#define OPC_TYPE_DOUBLE		8
#define OPC_TYPE_UNSIGNED	9
#define OPC_TYPE_INT		10
#define OPC_TYPE_BOOLEAN	11
*/

struct OPCTypeT {
    struct OPCTreeComplexNodeContextT node;
    OPCSimpleType type;
    OPCTypeOptions options;

    unsigned long element_count;
    char *terminator;			/* hexBinary */
    OPCType element_count_ref;
    
    unsigned long size;			/* 0 - variable */

    unsigned char align;
    unsigned char is_pointer;
};


#include <opcsimpletypes.h>

OPCType opcTypeCreate(OPCMallocContext mctx);
int opcTypeInit(OPCType ctx, OPCSimpleType type, OPCDestroyContextFunction destructor);
void opcTypeFree(OPCType ctx);
void opcTypeDestroy(OPCType ctx);

void opcTypeSetMaster(OPCType ctx);
void opcTypeResetMaster(OPCType ctx);

void opcTypeSetElementCount(OPCType ctx, unsigned long element_count);
void opcTypeSetElementCountRef(OPCType ctx, OPCType ref);
void opcTypeSetTerminator(OPCType ctx, const char *terminator);
void opcTypeSetExternal(OPCType ctx);

//int opcTypePush(OPCType ctx, OPCType child);
//int opcTypeRead(OPCType ctx, OPCFormatContext format, void *source);
//int opcTypeWrite(OPCType ctx, OPCFormatContext format, void *source);
//int opcTypeCopy(OPCType ctx, void *source); // Make copy of local data

#endif /* _OPC_TYPE_H */
