#ifndef _OPC_CHUNK_POOL
#define _OPC_CHUNK_POOL

#include <opcmalloc.h>
#include <lock.h>
#include <opcdatachunk.h>

typedef struct OPCChunkPoolContextT *OPCChunkPoolContext;

struct OPCChunkPoolContextT {
    OPCMallocContext malloc;
    LockContext lock;
    
    unsigned char bins;    
    OPCDataChunkContext *first_chunk;
    OPCDataChunkContext *last_chunk;
};

OPCChunkPoolContext opcChunkPoolCreateContext(OPCMallocContext mctx);
int opcChunkPoolInitContext(OPCChunkPoolContext ctx, unsigned char bins);
void opcChunkPoolFreeContext(OPCChunkPoolContext ctx);
void opcChunkPoolDestroyContext(OPCChunkPoolContext ctx);

OPCDataChunkContext opcChunkPoolGetChunk(OPCChunkPoolContext ctx, OPCRepresentationInfo *definfo, unsigned short int formats);
void opcChunkPoolReturnChunk(OPCChunkPoolContext ctx, OPCDataChunkContext chunk);

#endif /* _OPC_CHUNK_POOL */
