#ifndef _OPC_REQUESTBROWSE_H
#define _OPC_REQUESTBROWSE_H

#include <opcstringlist.h>
#include <opcrequest.h>
#include <opcitem.h>

struct OPCRequestBrowseContextT {
    xmlChar *item;			// OPC Item identifier
    OPCTreeContext tree;
    OPCStringList subitems;
    OPCStringList position;

    OPCItemBrowseFilter browse_filter;
    xmlChar *name_filter;
    xmlChar *vendor_filter;
    
    unsigned char return_all_properties;
    unsigned char return_property_values;
    unsigned char return_error_text;
    
    unsigned long max_elements_returned;

// property_names???
    const char* locale;
};

typedef struct OPCRequestBrowseContextT *OPCRequestBrowseContext;



OPCRequestBrowseContext opcRequestBrowseCreateContext();
int opcRequestBrowseInitContext(OPCRequestBrowseContext ctx, OPCRequestContext rctx, xmlNodePtr node);
int opcRequestBrowseCheckContext(OPCRequestBrowseContext ctx, OPCRequestContext rctx, xmlNodePtr node);
void opcRequestBrowseFreeContext(OPCRequestBrowseContext ctx);
void opcRequestBrowseDestroyContext(OPCRequestBrowseContext ctx);

int opcRequestBrowseNextElement(OPCRequestBrowseContext ctx, xmlNodePtr pnode);
int opcRequestBrowseAnswer(OPCRequestBrowseContext ctx, xmlNodePtr pnode);

#endif /* _OPC_REQUESTBROWSE_H */
