#ifndef _OPC_REQUESTPOOL_H
#define _OPC_REQUESTPOOL_H

#include <libxml/tree.h>
#include <libxml/xmlschemas.h>

#include <opc.h>
#include <opcrequest.h>

#include <hashtable.h>
#include <opcmalloc.h>

struct OPCRequestPoolContextT {
    OPCMallocContext malloc;
    OPCRequestContext *pool;		// Not used realy, just for fun
    OPCContext sctx;

    xmlSchemaParserCtxtPtr schema_parser;
    xmlSchemaPtr schema_rep;
    xmlSchemaValidCtxtPtr schema_ctx;

    HashTable opc_commands;
};

typedef struct OPCRequestPoolContextT *OPCRequestPoolContext;

OPCRequestPoolContext opcRequestPoolCreateContext(OPCMallocContext mctx);
int opcRequestPoolInitContext(OPCRequestPoolContext ctx, OPCContext sctx);
void opcRequestPoolFreeContext(OPCRequestPoolContext ctx);
void opcRequestPoolDestroyContext(OPCRequestPoolContext ctx);
OPCRequestContext opcRequestPoolGetRequest(OPCRequestPoolContext ctx);
int opcRequestPoolReturnRequest(OPCRequestPoolContext ctx, OPCRequestContext rctx);

#endif /* _OPC_REQUESTPOOL_H */
