#ifndef _OPC_REQUESTPROCESS_H
#define _OPC_REQUESTPROCESS_H

#include <opcrequest.h>

int opcRequestProcessOPC(OPCRequestContext ctx);

struct OPCCommandsT {
    char *name;
    int (*func)(OPCRequestContext ctx);
};

typedef struct OPCCommandsT *OPCCommand;

#define OPC_COMMANDS 20

int opcRequestGetStatus(OPCRequestContext ctx);
int opcRequestBrowse(OPCRequestContext ctx);
int opcRequestGetProperties(OPCRequestContext ctx);
int opcRequestRead(OPCRequestContext ctx);
int opcRequestSubscribe(OPCRequestContext ctx);
int opcRequestSubscribePolledRefresh(OPCRequestContext ctx);
int opcRequestSubscriptionCancel(OPCRequestContext ctx);
int opcRequestWrite(OPCRequestContext ctx);

#ifdef _OPC_REQUESTPOOL_C
static const struct OPCCommandsT opc_commands_ctx[] = {
    {"GetStatus",&opcRequestGetStatus},
    {"Browse",&opcRequestBrowse},
    {"GetProperties",&opcRequestGetProperties},
    {"Read",&opcRequestRead},
    {"Subscribe",&opcRequestSubscribe},
    {"SubscribePolledRefresh",&opcRequestSubscribePolledRefresh},
    {"SubscriptionCancel",&opcRequestSubscriptionCancel},
    {"Write",&opcRequestWrite},
    {NULL,NULL}
};

#endif /* _OPC_COMMANDS_INCLUDE */

#endif /* _OPC_REQUESTPOOL_H */
