#ifndef _CONDITION_H
#define _CONDITION_H

#include <time.h>
#include <pthread.h>
#include <opcmalloc.h>

struct ConditionContextT {
    OPCMallocContext malloc;
    pthread_cond_t cond;
    pthread_mutex_t mutex;
    unsigned char initialized;
};

typedef struct ConditionContextT *ConditionContext;

ConditionContext ConditionCreateContext(OPCMallocContext mctx);
int ConditionInitContext(ConditionContext ctx);
void ConditionFreeContext(ConditionContext ctx);
void ConditionDestroyContext(ConditionContext ctx);

void ConditionBroadcast(ConditionContext ctx);
void ConditionSend(ConditionContext ctx);
void ConditionPreLock(ConditionContext ctx);
void ConditionUnLock(ConditionContext ctx);
void ConditionWait(ConditionContext ctx);
void ConditionWaitLocked(ConditionContext ctx);
int ConditionTimedWait(ConditionContext ctx, time_t sec);
int ConditionTimedWaitLocked(ConditionContext ctx, time_t sec);

#endif /* _CONDITION_H */
