#ifndef _OPC_PLUGINSET_H
#define _OPC_PLUGINSET_H

#include <opcplugin.h>
#include <opcmalloc.h>

struct OPCPluginSetContextT {
    OPCMallocContext malloc;

    char *path;
    void *plugin_attribute;
    OPCPluginContext plugin;
    int run;
};

typedef struct OPCPluginSetContextT *OPCPluginSetContext;

OPCPluginSetContext opcPluginSetCreateContext(OPCMallocContext mctx);
int opcPluginSetInitContext(OPCPluginSetContext ctx, const char *path, void *attr);
void opcPluginSetZeroContext(OPCPluginSetContext ctx);
void opcPluginSetFreeContext(OPCPluginSetContext ctx);
void opcPluginSetDestroyContext(OPCPluginSetContext ctx);

int opcPluginRescanDir(OPCPluginSetContext ctx);


/* 
    Currently realesed in following way. 
    I think all plugins step by step comming to required Status. I mean if sometime one of 
    plugins get right status value, it's actualy will presist same until all others don't get
    to this status.
    
    It's possible do in standard way but I think this one is correct one for required purposes.
    And implementing standard one may finish in numerous deadlocks.
    
    See thread.h
*/

void opcPluginSetSetStatus(OPCPluginSetContext ctx, dword bits);
void opcPluginSetSetStatusBits(OPCPluginSetContext ctx, dword bits);
void opcPluginSetResetStatusBits(OPCPluginSetContext ctx, dword bits);
int opcPluginSetCheckStatusBitsOn(OPCPluginSetContext ctx, dword bits);
int opcPluginSetCheckStatusBitsOff(OPCPluginSetContext ctx, dword bits);
int opcPluginSetCheckStatusBits(OPCPluginSetContext ctx, dword onbits, dword offbits);
int opcPluginSetCheckStatusSomeBitsOn(OPCPluginSetContext ctx, dword bits);
int opcPluginSetCheckStatusSomeBitsOff(OPCPluginSetContext ctx, dword bits);
int opcPluginSetCheckStatusSomeBits(OPCPluginSetContext ctx, dword onbits, dword offbits);
void opcPluginSetWaitStatusBitsOn(OPCPluginSetContext ctx, dword bits);
void opcPluginSetWaitStatusBitsOff(OPCPluginSetContext ctx, dword bits);
void opcPluginSetWaitStatusBits(OPCPluginSetContext ctx, dword onbits, dword offbits);
void opcPluginSetWaitStatusSomeBitsOn(OPCPluginSetContext ctx, dword bits);
void opcPluginSetWaitStatusSomeBitsOff(OPCPluginSetContext ctx, dword bits);
void opcPluginSetWaitStatusSomeBits(OPCPluginSetContext ctx, dword onbits, dword offbits);
void opcPluginSetWaitTerminate(OPCPluginSetContext ctx);
void opcPluginSetTerminateAndWait(OPCPluginSetContext ctx);
int opcPluginSetIsTerminated(OPCPluginSetContext ctx);

int opcPluginSetStart(OPCPluginSetContext ctx);
int opcPluginSetStop(OPCPluginSetContext ctx);
int opcPluginSetBreak(OPCPluginSetContext ctx);
int opcPluginSetTerminate(OPCPluginSetContext ctx);
void opcPluginSetWaitTerminate(OPCPluginSetContext ctx);
void opcPluginSetTerminateAndWait(OPCPluginSetContext ctx);
int opcPluginSetIsTerminated(OPCPluginSetContext ctx);

#endif /* _OPC_PLUGINSET_H */
