#ifndef _OPC_SIGNAL_H
#define _OPC_SIGNAL_H

#include <signal.h>

#include <opcmalloc.h>
#include <lock.h>
#include <opcstringlist.h>

#define OPC_SIGNAL_TERMINATE OPC_SIGNAL_USR1

typedef enum OPCSignalT OPCSignal;

enum OPCSignalT {
    OPC_SIGNAL_USR1 = 0,
    OPC_SIGNAL_USR2
};

typedef struct OPCSignalContextT *OPCSignalContext;

struct OPCSignalContextT {
    OPCMallocContext malloc;
    LockContext lock;
    
    OPCStringList usr1;
    OPCStringList usr2;
    
    unsigned char ExitFlag;
};



OPCSignalContext opcSignalCreateContext(OPCMallocContext mctx);
int opcSignalInitContext(OPCSignalContext ctx);
int opcSingalFreeContext(OPCSignalContext ctx);
void opcSignalDestroyContext(OPCSignalContext ctx);

int opcSignalRegister(OPCSignalContext ctx, OPCSignal sig);
int opcSignalCancel(OPCSignalContext ctx, OPCSignal sig);
int opcSignalSend(OPCSignalContext ctx, OPCSignal sig);
int opcSignalSendTo(pthread_t thread, OPCSignal sig);

int opcSignalTerminate(OPCSignalContext ctx);
int opcSignalIsTerminated(OPCSignalContext ctx);

int opcSignalAccept(int s, int *newsock);
int opcSignalAcceptMulti(unsigned long number, int *s, int *newsock);
int opcSignalRead(int s, void *buf, size_t len, int flags, unsigned long *rbytes);
int opcSignalWrite(int s, const void *buf, size_t len, int flags, unsigned long *wbytes);

#endif /* _OPC_SIGNAL_H */
