#ifndef _DIME_H
#define _DIME_H

#include <opclib_types.h>

/*
    Simplified DIME header generation library.
*/


typedef void *DimeHeader;

typedef enum DimeTypeT DimeType;

enum DimeTypeT {
    DIME_TYPE_NOTAPPLICABLE = 0,
    DIME_TYPE_MIME,
    DIME_TYPE_URI,
    DIME_TYPE_NONE,
    DIME_TYPE_BINARY,
    DIME_TYPE_XML
};


int dimeSendHeader(const char *id, unsigned long size, DimeType type, const char *type_name, unsigned char first, unsigned char last, unsigned char chunked, OPCSendFunction func, void *cctx);
int dimeSendChunk(unsigned long size, unsigned char last, OPCSendFunction func, void *cctx);
int dimeSendCloseChunk(OPCSendFunction func, void *cctx);
int dimeSendCloseRecord(OPCSendFunction func, void *cctx);

#endif /* _DIME_H */
