#ifndef _OPC_ENUMERATION_H
#define _OPC_ENUMERATION_H

#include <opcmalloc.h>
#include <hashtable.h>

typedef struct OPCEnumerationBucketT *OPCEnumerationBucket;
struct OPCEnumerationBucketT {
    char *string;
    unsigned long id;
};


typedef struct OPCEnumerationContextT *OPCEnumerationContext;
struct OPCEnumerationContextT {
    OPCMallocContext malloc;
    HashTable hash;
    OPCEnumerationBucket bucket;
    unsigned char destroy_bucket;
    unsigned long maxid;
    char *string;
};

OPCEnumerationContext opcEnumerationCreateContext(OPCMallocContext mctx);
// Assuming what bucket will persist in memory whole live cickle
int opcEnumerationInitContext(OPCEnumerationContext ctx, OPCEnumerationBucket bucket);
int opcEnumerationInitContextFromArray(OPCEnumerationContext ctx, const char **title_array, unsigned char copy_strings);
int opcEnumerationInitContextFromString(OPCEnumerationContext ctx, const char *titles, unsigned char copy_string);
void opcEnumerationFreeContext(OPCEnumerationContext ctx);
void opcEnumerationDestroyContext(OPCEnumerationContext ctx);

unsigned long opcEnumerationGetID(OPCEnumerationContext ctx, const char *str);
const char *opcEnumerationGetString(OPCEnumerationContext ctx, unsigned long number);
OPCEnumerationBucket opcEnumerationGetBucketByString(OPCEnumerationContext ctx, const char *str);
OPCEnumerationBucket opcEnumerationGetBucketByID(OPCEnumerationContext ctx, unsigned long number);

#endif /* _OPC_ENUMERATION_H */
