#include <stdlib.h>
#include <assert.h>

#include <opcdebug.h>
#include <opcmalloc.h>

OPCMallocContext opcMallocCreateContext(OPCMallocContext mctx) {
    OPCMallocContext ctx;
    opcDebugServer(OPC_DEBUG_NOTICE, "opcMallocCreateContext");

    if (mctx) ctx = (OPCMallocContext)opcMalloc(mctx,sizeof(struct OPCMallocContextT));
    else {
	    // Should be allocated from shared segment...
	ctx = (OPCMallocContext)malloc(sizeof(struct OPCMallocContextT));
    }

    if (ctx) ctx->parrent = mctx;
    return ctx;
}

void opcMallocDestroyContext(OPCMallocContext ctx) {
    opcDebugServer(OPC_DEBUG_NOTICE, "opcStateDestroyContext");

    assert(ctx);
    if (ctx->parrent) opcFree(ctx->parrent,ctx);
    else free(ctx);
}


void *opcMalloc(OPCMallocContext ctx, size_t size) {
    assert(size>0);

/*    if (ctx) {
    } else */
    return malloc(size);
}

void *opcRealloc(OPCMallocContext ctx, void *ptr, size_t size) {
/*  if (ctx) {
    } else */
    return realloc(ptr,size);
}

void *opcCalloc(OPCMallocContext ctx, size_t nmemb, size_t size) {
/*    if (ctx) {
    } else */
    return calloc(nmemb,size);
}

void *opcFree(OPCMallocContext ctx, void *ptr) {
    assert(ptr);

/*    if (ctx) {
    } else */
    free(ptr);
}
