#ifndef _OPC_MALLOC_H
#define _OPC_MALLOC_H

#include <stdio.h>
/*
OPCMalloc is special memory allocation for OPC Server data structures and
intercommunication between OPCRequest threads.
It should use shared memory to hold all data and share it between all 
OPCRequest clients. OPCRequest local data structures should be allocated
with standard malloc or some other routines wich would use process local
memory.
*/

typedef struct OPCMallocContextT *OPCMallocContext;

struct OPCMallocContextT {
    OPCMallocContext parrent;
};

OPCMallocContext opcMallocCreateContext(OPCMallocContext mctx);
void opcMallocDestroyContext(OPCMallocContext ctx);

void *opcMalloc(OPCMallocContext ctx, size_t size);
void *opcRealloc(OPCMallocContext ctx, void *ptr, size_t size);
void *opcCalloc(OPCMallocContext ctx, size_t nmemb, size_t size);
void *opcFree(OPCMallocContext ctx, void *ptr);


int opcMallocInit();
void opcMallocDestroy();

#endif /* _OPC_MALLOC_H */
