#ifndef _OPC_STRINGLIST_H
#define _OPC_STRINGLIST_H

#include <opcmalloc.h>

typedef struct OPCStringListT *OPCStringList;

struct OPCStringListT {
    OPCMallocContext malloc;
    void *item;
    unsigned long size;
    OPCStringList next;
    OPCStringList free;
};

OPCStringList opcStringListCreate(OPCMallocContext mctx);
void opcStringListFree(OPCStringList list);
void opcStringListDestroy(OPCStringList list);
int opcStringListAdd(OPCStringList list, const void *item, unsigned long size);
int opcStringListIsIn(OPCStringList list, const void *item, unsigned long size);
int opcStringListRemove(OPCStringList list, const void *item, unsigned long size);
int opcStringListRemoveMulti(OPCStringList list, const void *item, unsigned long size);
int opcStringListIsEmpty(OPCStringList list);

#endif /* _OPC_STRINGLIST_H */
