#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <opcmalloc.h>
#include <opctools.h>

int opcExchangeString(OPCMallocContext mctx, char **dst, const char *src) {
    char *tmp;
    if (!src) {
	if (*dst) opcFree(mctx, *dst);
	return 0;
    }
    tmp = (char*)opcMalloc(mctx, (strlen(src)+1)*sizeof(char));
    if (!tmp) return -1;
    strcpy(tmp,src);
    if (*dst) opcFree(mctx, *dst);
    *dst=tmp;
    return 0;
}

int opcExchangeStringChars(OPCMallocContext mctx, char **dst, const char *src, unsigned chars) {
    char *tmp;
    if (!src) {
	if (*dst) opcFree(mctx, *dst);
	return 0;
    }
    tmp = (char*)opcMalloc(mctx, (chars+1)*sizeof(char));
    if (!tmp) return -1;
    strncpy(tmp,src,chars);tmp[chars]=0;
    if (*dst) opcFree(mctx, *dst);
    *dst=tmp;
    return 0;
}

char *opcCreateFullName(OPCMallocContext mctx, const char *path, const char *filename) {
    char *fullname;
    if ((path)&&(filename)) {
	fullname = (char*)opcMalloc(mctx, (strlen(path)+strlen(filename)+2)*sizeof(char));
	if (fullname) sprintf(fullname,"%s/%s",path,filename);
    } else if (filename) {
	fullname = (char*)opcMalloc(mctx, (strlen(filename)+2)*sizeof(char));
	if (fullname) {
	    if (filename[0]!='/') sprintf(fullname,"/%s",filename);
	    else strcpy(fullname,path);
	}
    } else if (path) {
	fullname = (char*)opcMalloc(mctx, (strlen(path)+2)*sizeof(char));
	if (fullname) {
	    if (!path[0]) strcpy(fullname,"/");
	    else strcpy(fullname,path);
	}
    } else {
	fullname = (char*)opcMalloc(mctx, 2*sizeof(char));
	if (fullname) strcpy(fullname,"/");
    }
    return fullname;    
}

time_t GetFileModificationTime(const char *file) {
    struct stat st;
    if (stat(file,&st)) return 0;
    return st.st_mtime;
}

int *ThreadReturnInt(OPCMallocContext mctx, int err) {
    int *ret;
    ret = (int*)opcMalloc(mctx,sizeof(int));
    *ret = err;
    return ret;
}
