#ifndef _OPC_TREE_NODE_H
#define _OPC_TREE_NODE_H

#include <opclib.h>

typedef struct OPCTreeNodeContextT *OPCTreeNodeContext;
typedef struct OPCTreeComplexNodeContextT *OPCTreeComplexNodeContext;

struct OPCTreeNodeContextT {
    OPCMallocContext malloc;
    OPCDestroyContextFunction destructor;
    OPCTreeComplexNodeContext parrent;
    OPCTreeNodeContext next, prev;
};


OPCTreeNodeContext opcTreeNodeCreateContext(OPCMallocContext mctx);
inline int opcTreeNodeInitContext(OPCTreeNodeContext ctx, OPCDestroyContextFunction destructor);
inline void opcTreeNodeFreeContext(OPCTreeNodeContext ctx);
void opcTreeNodeDestroyContext(OPCTreeNodeContext ctx);

inline int opcTreeNodeUnlink(OPCTreeNodeContext ctx);
inline int opcTreeNodeInsertAfter(OPCTreeNodeContext ctx, OPCTreeNodeContext sibling);
inline int opcTreeNodeInsertBefore(OPCTreeNodeContext ctx, OPCTreeNodeContext sibling);


struct OPCTreeComplexNodeContextT {
    struct OPCTreeNodeContextT node;
    OPCTreeNodeContext first_child, last_child;
};

OPCTreeComplexNodeContext opcTreeComplexNodeCreateContext(OPCMallocContext mctx);
inline int opcTreeComplexNodeInitContext(OPCTreeComplexNodeContext ctx, OPCDestroyContextFunction destructor);
inline void opcTreeComplexNodeFreeContext(OPCTreeComplexNodeContext ctx);
void opcTreeComplexNodeDestroyContext(OPCTreeComplexNodeContext ctx);

inline int opcTreeComplexNodeAddChild(OPCTreeComplexNodeContext ctx, OPCTreeNodeContext child);


#endif /* _OPC_TREE_NODE_H */
