#ifndef _OPC_XML_H
#define _OPC_XML_H

#include <libxml/tree.h>

#include <opctime.h>

xmlNodePtr xmlFindNode(const xmlNodePtr parent, const xmlChar *name, const xmlNsPtr ns);
xmlNodePtr xmlFindNodeByHref(const xmlNodePtr parent, const xmlChar *name, const char *ns);

int opcXmlGetPropInt(const xmlNodePtr node, const xmlChar *name, int default_value);
long opcXmlGetPropLong(const xmlNodePtr node, const xmlChar *name, long default_value);
unsigned char opcXmlGetPropBoolean(const xmlNodePtr node, const xmlChar *name, unsigned char default_value);
const char *opcXmlGetPropString(const xmlNodePtr node, const xmlChar *name, const char *default_value);
OPCTime opcXmlGetPropDateTime(const xmlNodePtr node, const xmlChar *name, OPCTime time);

void opcXmlSetPropInt(xmlNodePtr node, const xmlChar *name, int value);
void opcXmlSetPropLong(xmlNodePtr node, const xmlChar *name, int value);
void opcXmlSetPropBoolean(xmlNodePtr node, const xmlChar *name, int value);

#endif /* _OPC_LIBXML_H */
