#ifndef _BACKEND_H
#define _BACKEND_H

#include <opcpluginset.h>
#include <opcmalloc.h>
#include <opcsignal.h>

//#include <backendchild.h>

#define max_backend_childs 10

typedef struct OPCBackendContextT *OPCBackendContext;

struct OPCBackendContextT {
    int socket;
    
    char *socket_name;

    OPCSignalContext sigctx;
    
    OPCMallocContext malloc;
    OPCPluginSetContext plugins;
    
    OPCContext sctx;
};

OPCBackendContext opcBackendCreateContext(OPCMallocContext mctx);
int opcBackendInitContext(OPCBackendContext ctx, OPCContext sctx, OPCSignalContext sigctx);
int opcBackendInitSocket(OPCBackendContext ctx, const char *socket_name);
void opcBackendFreeContext(OPCBackendContext ctx);
void opcBackendDestroyContext(OPCBackendContext ctx);
int *opcBackendListen(OPCBackendContext ctx);

#endif /* _BACKEND_H */
