#ifndef _BUFFERPOOL_H
#define _BUFFERPOOL_H

#define opc_bufferpull_step 		10	/* ToDo: 10 and find error */
#define opc_bufferpull_fbmaxratio	4	/* undef if not required */
#define opc_bufferpull_cleanupratio	8

/* Permit getting buffers from buffer pool being destroyed */
#define opc_bufferpull_permitgetdestroy		

typedef struct BufferPoolT *BufferPool;

struct BufferPoolT {
    unsigned char destroy;	// If set up, buffer in destruction state
    unsigned long buffersize;	// Size of buffer
    unsigned long bpsize;	// Maximal items buffer pool can store
    unsigned long nbusy;	// Number of allocated busy buffers
    unsigned long nfree;	// Number of allocated free buffers
    char **busy;		// Busy buffers
    char **free;		// Free buffers

    pthread_mutex_t mutex;	// For multithread cooperation
};

BufferPool BufferPoolCreate(int size);
void BufferPoolCleanup(BufferPool ctx);
void BufferPoolClearFree(BufferPool ctx);
void BufferPoolDestroy(BufferPool ctx);
void BufferPoolDestroyForce(BufferPool ctx);
char *BufferPoolGet(BufferPool ctx);
int BufferPoolReturn(BufferPool ctx, char *buffer);

#endif /* _BUFFERPOOL_H */
