#ifndef _FRONTEND_H
#define _FRONTEND_H

typedef struct OPCFrontendContextT *OPCFrontendContext;

#include <opcrequestpool.h>

#include <frontendchild.h>
#include <bufferpool.h>
#include <opcsignal.h>
#include <lock.h>

#ifdef _FRONTEND_C
#define saddr "/tmp/opc/hell.opc/socket"
#endif /* _FRONTEND_C */
#define max_frontend_childs 10

struct OPCFrontendContextT {
    int socket;
    int isocket;
    OPCSignalContext sigctx;
    BufferPool buffpool;
    OPCRequestPoolContext rpctx;
    LockContext lock;
    OPCFrontendChildContext child[max_frontend_childs];
};

OPCFrontendContext opcFrontendCreateContext();
int opcFrontendInitContext(OPCFrontendContext ctx, OPCRequestPoolContext rpctx, BufferPool bp, OPCSignalContext sigctx);
void opcFrontendFreeContext(OPCFrontendContext ctx);
void opcFrontendDestroyContext(OPCFrontendContext ctx);
int *opcFrontendListen(OPCFrontendContext ctx);
void opcFrontendCleanupChilds(OPCFrontendContext ctx);

#endif /* _FRONTEND_H */
