#ifndef _OPCSERVER_H
#define _OPCSERVER_H

typedef struct OPCServerContextT* OPCServerContext;
#include <opcmalloc.h>

#include <opc.h>
#include <opcrequestpool.h>

#include <frontend.h>
#include <backend.h>
#include <bufferpool.h>
#include <opcsignal.h>

#define OPC_SERVER_BACKEND_INITIALIZED 1
#define OPC_SERVER_FRONTEND_INITIALIZED 2
#define OPC_SERVER_TERMINATE_FLAG 4
#define OPC_SERVER_CONTEXT_INITIALIZED 8

struct OPCServerContextT {
    OPCMallocContext malloc;
    OPCContext ctx;
    pthread_t frontend;
    OPCFrontendContext fctx;
    pthread_t backend;
    OPCBackendContext bctx;
    OPCRequestPoolContext rpctx;
    BufferPool buffpool;
    OPCSignalContext sigctx;
    unsigned char status;
};

int opcServerInit();
void opcServerDestroy();

OPCServerContext opcServerCreateContext();
int opcServerInitContext(OPCServerContext ctx);
void opcServerFreeContext(OPCServerContext ctx);
void opcServerDestroyContext(OPCServerContext ctx);
int opcServerRun(OPCServerContext ctx);
int opcServerTerminate(OPCServerContext ctx);
int opcServerIsTerminating(OPCServerContext ctx);
void opcServerMantain(OPCServerContext ctx);

#endif /* _OPCSERVER_H */
