<?
unset($http_error);

function frbytes($fp, $b) {
    global $http_error;
    
    $ret="";
    while((!feof($fp))&&(strlen($ret)<$b)) {
	$ret.=fread($fp,$b-strlen($ret));
    }
    if (strlen($ret)<$b) {
	$http_error="Connection broken";
	return "";
    }
    return $ret;
}


function httpRequest($srv, $request, $binary=null) {
    global $chunk_size;
    global $http_error;
    
    $url = parse_url($srv);
    if (preg_match("/^https:/",$url["sheme"])) $prefix="ssl://";
    else $prefix="";
    if ($url["port"]) $port=$url["port"];
    else $port="80";
    $fp = fsockopen($prefix . $url["host"],$port);
    if (!$fp) {
	$http_error="Error connecting OPC XML-DA server";
	return NULL;
    }

    fputs($fp,"POST " . $srv . " HTTP/1.1\r\n");
    fputs($fp,"Host: " . $url["host"] . "\r\n");
    fputs($fp,"Content-type: text/xml\r\n");
    fputs($fp,"Content-length: " . strlen($request) . "\r\n\r\n");
    fputs($fp, $request);

    $cmd=fgets($fp,$chunk_size);
    if (!preg_match("/^HTTP\/\d.\d (\d{3})/",$cmd,$m)) {
	$http_error="Non HTTP response from OPC XML-DA server";
	fclose($fp);
	return null;
    }
    if ($m[1]!=200) {
	print $ret;
	while(!feof($fp)) {
	    $ret.=fgets($fp,$chunk_size);
	}
	preg_match("/<body>(.*)<\/body>/ims",$ret,$m);
	$http_error=$m[1];
	fclose($fp);
	return null;
    }
    
    $chunked=0;
    while((!feof($fp))) {
	$ret=fgets($fp,$chunk_size);
	if (!preg_match("/([^:]+): (.+)/",$ret,$m)) break;
	switch ($m[1]) {
	    case "Content-Type":
		if (!preg_match("/text\/xml/",$m[2])) {
		    $http_error="Non XML response from OPC XML-DA server";
		    fclose($fp);
		    return null;
		}
	    break;
	    case "Content-Length":
		$content_length=$m[2];
	    break;
	    case "Transfer-Encoding":
		// Hmm... or everything expect identity as writen is spec
		if (preg_match("/chunked/",$m[2])) $chunked=1;
	    break;
	}
    }
    if (!preg_match("/^\s*$/",$ret)) {
	$http_error="Response from OPC XML-DA server violates HTTP rules";
	fclose($fp);
	return null;
    }
    
    $ret="";
    if ($chunked) {
	while (!feof($fp)) {
	    $size="";
	    while (preg_match("/^\s*$/",$size)) $size=fgets($fp,$chunk_size);
	    if (!preg_match("/^\s*([\dABCDEF]{1,4})\s*$/i",$size,$m)) {
		$http_error="Incomplete chunked messages recieved from OPC XML-DA server";
		fclose($fp);
		return null;
	    }
	    $size=hexdec($m[1]);
	    if ($size==0) break;
	    $ret.=frbytes($fp,$size);
	    if ($http_error) {
		fclose($fp);
		return null;
	    }
	}
	if (feof($fp)) {
	    $http_error="Connection broken";
	    fclose($fp);
	    return null;
	}
    } else {
	if ($content_length) {
	    $ret=frbytes($fp,$content_length);
	    if ($http_error) {
		fclose($fp);
		return null;
	    }
	} else {
	    while(!feof($fp)) {
		$ret.=fgets($fp,$chunk_size);
	    }
	}
    }
    fclose($fp);
    return $ret;
}
?>